<template>
  <div>
    <v-app-bar app color="white" dense>
      <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>
      <v-spacer></v-spacer>
      <v-menu bottom offset-y transition="slide-y-transition">
        <template v-slot:activator="{ on, attrs }">
          <v-btn icon v-bind="attrs" v-on="on">
            <v-icon>mdi-account</v-icon>
          </v-btn>
        </template>

        <v-list v-if="loggedIn">
          <v-list-item v-for="(item, i) in loggedItems" :key="i" @click="handleAction(item)">
            <v-list-item-icon>
              <v-icon v-text="item.icon"></v-icon>
            </v-list-item-icon>
            <v-list-item-content>
              <v-list-item-title>{{ item.title }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>

        <v-list v-if="!loggedIn">
          <v-list-item v-for="(item, i) in notLoggedItems" :key="i" @click="handleAction(item)">
            <v-list-item-icon>
              <v-icon v-text="item.icon"></v-icon>
            </v-list-item-icon>
            <v-list-item-content>
              <v-list-item-title>{{ item.title }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-app-bar>

        <v-navigation-drawer v-model="drawer" app color="primary-light">
          <v-list>
            <v-list-item-group :value="selectedItem">
                <v-list-item class="center-title title">
                    <v-list-item-title>
                        <router-link :to="{ name: 'home' }" class="white--text" style="text-decoration: none;">
                            <h1>
                          <v-avatar v-if="logoUrl" size="32">
                            <!-- <v-icon dark>mdi-alarm</v-icon> -->
                            <v-img  :src="logoUrl"></v-img>
                          </v-avatar>
                              {{company.name}}
                              </h1>
                        </router-link>
                    </v-list-item-title>
                </v-list-item>

          <v-divider></v-divider>

          <v-list-item
            v-for="item in drawerItems"
            :key="item.title"
            link
            @click="handleRoute(item)"
          >
            <v-list-item-avatar class="custom-icon">
              <v-icon class="white--text">{{item.icon}}</v-icon>
            </v-list-item-avatar>
            <v-list-item-content>
              <v-list-item-title>
                <h4 class="white--text">{{item.title}}</h4>
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list-item-group>
      </v-list>
    </v-navigation-drawer>
  </div>
</template>

<script>
import { ENTRYPOINT } from "../../config/entrypoint";
import { mapGetters, mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";

export default {
  name: "Header",
  components: {},
  computed: {
    ...mapGetters("user", {
      loggedIn: "getLoggedIn"
    }),
    ...mapFields("admin", ["company"])
  },
  data: () => ({
    loggedItems: [
      {
        title: "Profile",
        icon: "mdi-account-box",
        action: "redirect",
        route: "profileUser"
      },
      { title: "Se déconnecter", icon: "mdi-logout", action: "logout" }
    ],
    notLoggedItems: [
      {
        title: "Connexion",
        icon: "mdi-login",
        action: "redirect",
        route: "login"
      },
      {
        title: "Inscription",
        icon: "mdi-account-plus",
        action: "redirect",
        route: "register"
      }
    ],
    drawerItems: [
      {
        title: "Mon entreprise",
        icon: "mdi-card-account-details",
        route: "adminCompany"
      },
      { title: "Mes magasins", icon: "mdi-store", route: "adminStores" },
      {
        title: "Mes produits",
        icon: "mdi-package-variant",
        route: "AdminProductList"
      },
      { title: "Mes codes promos", icon: "mdi-ticket", route: "PromoCodeList" },
      {
        title: "Mes collaborateurs",
        icon: "mdi-account-supervisor-circle",
        route: "adminCollaboratorsList"
      }
    ],
    selectedTab: null,
    drawer: true,
    selectedItem: null,
    logoUrl: null
  }),
  created() {
    for (let i = 0; i < this.drawerItems.length; i++) {
      const routing = this.drawerItems[i];
      if (routing.route === this.$route.name) {
        this.selectedItem = i + 1;
        return;
      }
    }
  },
  methods: {
    ...mapActions("user", ["logout"]),
    handleAction: function(value) {
      if (value.action === "redirect") {
        this.$router.push({ name: value.route });
      } else {
        this.logout();
        this.$router.push({ name: "login" });
      }
    },
    handleRoute: function(item) {
      this.$router.push({ name: item.route });
    }
  },
  watch: {
    company(newCompany) {
      if (newCompany && newCompany.logo) {
        this.logoUrl = ENTRYPOINT + "/media/" + newCompany.logo.filePath;
      }
    }
  }
};
</script>

<style>
.custom-header .v-toolbar__content {
  align-items: center !important;
  padding: 4px 95px;
}

.custom-tab-nav {
  color: white;
}

.custom-tab-link {
  text-decoration: none;
  width: 100%;
  height: 100%;
}
.custom-tab-link span {
  line-height: 48px;
}
.center-title {
  text-align: center;
}
.custom-icon {
  margin-right: 5px;
}
</style>

